/*******************************************************************************
 * FoxDownloadWatcherUI generated by Eliot.UELib using UE Explorer.
 * Eliot.UELib ? 2009-2015 Eliot van Uytfanghe. All rights reserved.
 * http://eliotvu.com
 *
 * All rights belong to their respective owners.
 *******************************************************************************/
class FoxDownloadWatcherUI extends Object within FoxUI
    native(UI);

var transient int PosX;
var transient int PosY;
var transient string LocTitle;
var transient float DefaultProgress;
var transient float DefaultETA;
var transient float TickFrequency;
var transient int MaxCacheSize;
var FoxUIProgressIndicatorWidget ProgressIndicatorWidget;
var bool bEnableTicking;
var bool bNotificationPumped;
var float AccumDt;
var array<float> CachedETAs;

function Initialize()
{
    // End:0x9A
    if(ProgressIndicatorWidget == none)
    {
        ProgressIndicatorWidget = Outer.ShowProgressIndicatorWidget(class'FoxUIProgressIndicatorWidget', "ProgressIndicator", PosX, PosY, LocTitle, DefaultProgress, DefaultETA);
        EnableTicking();
        AccumDt = 0.0;
    }
    //return;    
}

function Cleanup()
{
    // End:0x42
    if(ProgressIndicatorWidget != none)
    {
        Outer.HideProgressIndicatorWidget(ProgressIndicatorWidget);
        ProgressIndicatorWidget = none;
    }
    //return;    
}

event Tick(float DT)
{
    // End:0x51
    if(bEnableTicking)
    {
        AccumDt += DT;
        // End:0x51
        if(AccumDt >= TickFrequency)
        {
            AccumDt = 0.0;
            UpdateDisplay();
        }
    }
    //return;    
}

function EnableTicking()
{
    // End:0x26
    if(bEnableTicking == false)
    {
        bEnableTicking = true;
        UpdateDisplay();
    }
    //return;    
}

function DisableTicking()
{
    // End:0x1C
    if(bEnableTicking == true)
    {
        bEnableTicking = false;
    }
    //return;    
}

function ConditionalPumpSocialNotification()
{
    local FoxUI DynamicUI;

    DynamicUI = Outer;
    // End:0x173
    if(((((!bNotificationPumped && DynamicUI != none) && DynamicUI.OnlineSub != none) && NotEqual_InterfaceInterface(DynamicUI.OnlineSub.GameDownloadInterface, (none))) && DynamicUI.OnlineSub.GameDownloadInterface.IsGameComplete()) && DynamicUI.OnlineSub.GameDownloadInterface.DoesGameNeedRefresh())
    {
        bNotificationPumped = true;
        DynamicUI.PumpSocialNotification(31);
    }
    //return;    
}

function UpdateDisplay()
{
    local FoxUI DynamicUI;
    local OnlineGameDownloadInterface GDI;
    local array<int> ChunksToDo;
    local float Progress, ETA;
    local int I;
    local string LocDownloadComplete;

    DynamicUI = Outer;
    // End:0xD1
    if(((DynamicUI != none) && DynamicUI.OnlineSub != none) && NotEqual_InterfaceInterface(DynamicUI.OnlineSub.GameDownloadInterface, (none)))
    {
        GDI = DynamicUI.OnlineSub.GameDownloadInterface;
    }
    // End:0x391
    if(NotEqual_InterfaceInterface(GDI, (none)))
    {
        // End:0x1E7
        if(GDI.IsGameComplete())
        {
            // End:0x1E4
            if(ProgressIndicatorWidget != none)
            {
                ProgressIndicatorWidget.SetProgress(1.0);
                LocDownloadComplete = Outer.GetLocalizedString("Menu", "DownloadFinished");
                ProgressIndicatorWidget.SetETAText(LocDownloadComplete);
                DynamicUI.Menu.ui_conditionalShowFinishDownloadButton();
            }
        }
        // End:0x391
        else
        {
            ChunksToDo = GDI.GetTodoList();
            Progress = GDI.GetOverallProgress();
            ETA = GDI.GetChunksETA(ChunksToDo);
            CachedETAs.AddItem(ETA);
            // End:0x2BD
            if(CachedETAs.Length > MaxCacheSize)
            {
                CachedETAs.Remove(0, CachedETAs.Length - MaxCacheSize);
            }
            ETA = 0.0;
            I = 0;
            J0x2D7:
            // End:0x31B [Loop If]
            if(I < CachedETAs.Length)
            {
                ETA += CachedETAs[I];
                ++ I;
                // [Loop Continue]
                goto J0x2D7;
            }
            ETA /= float(CachedETAs.Length);
            // End:0x391
            if(ProgressIndicatorWidget != none)
            {
                ProgressIndicatorWidget.SetProgress(Progress);
                ProgressIndicatorWidget.SetETA(ETA);
            }
        }
    }
    //return;    
}

defaultproperties
{
    PosX=315
    PosY=265
    LocTitle="Downloading"
    DefaultETA=-1.0
    TickFrequency=0.250
    MaxCacheSize=12
}